package antlr;

/*
 * <b>SOFTWARE RIGHTS</b>
 * <p>
 * ANTLR 2.6.0 MageLang Institute
 * <p>
 * We reserve no legal rights to the ANTLR--it is fully in the
 * public domain. An individual or company may do whatever
 * they wish with source code distributed with ANTLR or the
 * code generated by ANTLR, including the incorporation of
 * ANTLR, or its output, into commerical software.
 * <p>
 * We encourage users to develop software with ANTLR. However,
 * we do ask that credit is given to us for developing
 * ANTLR. By "credit", we mean that if you use ANTLR or
 * incorporate any source code into one of your programs
 * (commercial product, research project, or otherwise) that
 * you acknowledge this fact somewhere in the documentation,
 * research report, etc... If you like ANTLR and have
 * developed a nice tool with the output, please mention that
 * you developed it using ANTLR. In addition, we ask that the
 * headers remain intact in our source code. As long as these
 * guidelines are kept, we expect to continue enhancing this
 * system and expect to make other tools available as they are
 * completed.
 * <p>
 * The ANTLR gang:
 * @version ANTLR 2.6.0 MageLang Institute
 * @author Terence Parr, <a href=http://www.MageLang.com>MageLang Institute</a>
 * @author <br>John Lilley, <a href=http://www.Empathy.com>Empathy Software</a>
 */
/** A token is minimally a token type.  Subclasses can add the text matched
 *  for the token and line info. 
 */
public class Token implements Cloneable {
	// constants
	public static final int MIN_USER_TYPE = 4;
	public static final int NULL_TREE_LOOKAHEAD = 3;
	public static final int INVALID_TYPE = 0;
	public static final int EOF_TYPE = 1;
	public static final int SKIP = -1;

	// each Token has at least a token type
	int type=INVALID_TYPE;
	
	// the illegal token object
	public static Token badToken = new Token(INVALID_TYPE, "<no text>");

	public Token() {;}
	public Token(int t) { type = t; }
	public Token(int t, String txt) { type = t; setText(txt); }
	public int getColumn() { return 0; }
	public int getLine() { return 0; }
	public String getText() { return "<no text>"; }
	public int getType() { return type; }
	public void setColumn(int c) {;}
	public void setLine(int l) {;}
	public void setText(String t) {;}
	public void setType(int t) { type = t; }
	public String toString() {
		return "[\""+getText()+"\",<"+type+">]";
	}
}