#ifndef INC_CommonASTNodeWithHiddenTokens_hpp__
#define INC_CommonASTNodeWithHiddenTokens_hpp__

/** A CommonAST whose initialization copies hidden token
 *  information from the Token used to create a node.
 */

#include "antlr/config.hpp"
#include "antlr/CommonASTNode.hpp"

class CommonASTNodeWithHiddenTokens : public CommonASTNode {
protected:
	RefToken hiddenBefore,hiddenAfter; // references to hidden tokens
public:
	RefToken getHiddenAfter() const
		{ return hiddenAfter; }
	RefToken getHiddenBefore() const
		{ return hiddenBefore; }

	void initialize(RefToken t);

	static ASTNode* factory();
};

#endif //INC_CommonASTNodeWithHiddenTokens_hpp__
