#include <iostream>
#include "ExprLexer.hpp"
#include "ExprParser.hpp"
#include "antlr/AST.hpp"
#include "antlr/CommonASTNode.hpp"

int main()
{
	using namespace std;
	try {
		ExprLexer lexer(cin);
		ExprParser parser(lexer);

		// set the type of tree node to create; this is default action
		// so it is unnecessary to do it here, but demos capability.
		parser.setASTNodeFactory(&CommonASTNode::factory);

		parser.expr();
//		antlr.CommonAST ast = (antlr.CommonAST)parser.getAST();
		RefAST ast = parser.getAST();
		if (ast) {
			cout << ast->toStringList() << endl;
		} else {
			cout << "null AST" << endl;
		}
	} catch(exception& e) {
		cerr << "exception: " << e.what() << endl;
	}
}

