// Generated from BackendOptions.opt
package at.dms.backend;

import gnu.getopt.Getopt;
import gnu.getopt.LongOpt;

public class BackendOptions extends at.dms.util.Options {

  public BackendOptions(String name) {
    super(name);
  }

  public BackendOptions() {
    this("Backend");
  }
  public boolean verbose = false;
  public int optimize = 2;
  public String destination = null;

  public boolean processOption(int code, Getopt g) {
    switch (code) {
    case 'v':
      verbose = !false; break;
    case 'O':
      optimize = getInt(g, 0); break;
    case 'd':
      destination = getString(g, ""); break;
    default:
      return super.processOption(code, g);
    }
    return true;
  }

  public String[] getOptions() {
    String[]	parent = super.getOptions();
    String[]	total = new String[parent.length + 3];
    System.arraycopy(parent, 0, total, 0, parent.length);
    total[parent.length + 0] = "  --verbose, -v:        Displays information while processing files [false]";
    total[parent.length + 1] = "  --optimize, -O<int>:  Level of optimization [2]";
    total[parent.length + 2] = "  --destination, -d<String>: Destination directory";
    
    return total;
  }


  public String getShortOptions() {
    return "vO:d:" + super.getShortOptions();
  }


  public void version() {
    System.out.println("version number: 1.4F released 05/23/2000");
  }


  public void usage() {
    System.err.println("usage: at.dms.optimize.Main [option]* [--help] <class-files>");
    version();  }


  public void help() {
    System.err.println("usage: at.dms.optimize.Main [option]* [--help] <class-files>");
    printOptions();
    System.err.println();
    System.err.println("THIS PROGRAM IS PART OF GNU KOPI, A SET OF GNU PACKAGES FOR JVM CODE GENERATION");
    System.err.println("MORE INFO:                 see: http://www.dms.at/kopi, http://www.gnu.org/kopi");
    System.err.println("THE GRAMMAR WAS DEVELOPED USING ANTLR.                 see http://www.antlr.org");
    version();
  }

  public LongOpt[] getLongOptions() {
    LongOpt[]	parent = super.getLongOptions();
    LongOpt[]	total = new LongOpt[parent.length + LONGOPTS.length];
    
    System.arraycopy(parent, 0, total, 0, parent.length);
    System.arraycopy(LONGOPTS, 0, total, parent.length, LONGOPTS.length);
    
    return total;
  }

  private static final LongOpt[] LONGOPTS = {
    new LongOpt("verbose", LongOpt.NO_ARGUMENT, null, 'v'),
    new LongOpt("optimize", LongOpt.REQUIRED_ARGUMENT, null, 'O'),
    new LongOpt("destination", LongOpt.REQUIRED_ARGUMENT, null, 'd')
  };
}
