/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: CBinaryField.java,v 1.2 2002/03/08 21:54:12 mrobilla Exp $
 */

package at.dms.kjc;

import at.dms.classfile.FieldInfo;

/**
 * This class represents loaded (compiled) class fields.
 */
public class CBinaryField extends CField {

  // ----------------------------------------------------------------------
  // CONSTRUCTORS
  // ----------------------------------------------------------------------

  /**
   * Constructs a field export
   * @param	owner		the owner of this field
   * @param	fieldInfo	a field info from a class file
   */
  public CBinaryField(CClass owner, FieldInfo fieldInfo) {
    super(owner,
	  fieldInfo.getModifiers(),
	  fieldInfo.getName().intern(),
	  CType.parseSignature(fieldInfo.getSignature()),
	  fieldInfo.isDeprecated());

    if (isFinal() && isStatic()) {
      Object		value = fieldInfo.getConstantValue();
      if (value != null) {
	setValue(JLiteral.createLiteral(getType(), value));
      }
    }
  }
}
