/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: CInitializable.java,v 1.2 2002/03/08 21:54:16 mrobilla Exp $
 */

package at.dms.kjc;

import at.dms.compiler.UnpositionedError;

/**
 * Interface for all left-value expression
 */
public interface CInitializable {

  /**
   * @return	true if this expression is an LValue at call time
   *		a final variable is a lvalue until it is initialized
   */
  boolean isLValue(CExpressionContext context);

  /**
   * Initialize this object
   * @exception	UnpositionedError an error if this object can't actually
   *		be assignated this may happen with final variables.
   */
  void initialize(CBodyContext ctxt) throws UnpositionedError;

  /**
   * @return	true if this expression is a variable already valued
   */
  boolean isInitialized(CExpressionContext context);

  /**
   * Generates a sequence of bytescodes
   * @param	code		the code list
   */
  void genStartStoreCode(CodeSequence code);

  /**
   * Generates a sequence of bytescodes
   * @param	code		the code list
   */
  void genEndStoreCode(CodeSequence code, boolean discardValue);
}

