/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: CModifier.java,v 1.2 2002/03/08 21:54:18 mrobilla Exp $
 */

package at.dms.kjc;

/**
 * This class represents all modifiers token
 * <pre> public protected private static final synchronized transient volatile native </pre>
 */
public class CModifier implements Constants {

  /**
   * generate a list of modifiers
   * @param	modifiers		the modifiers
   * @param	p			the destination
   */
  public static String toString(int modifier) {
    String	temp = "";
    for (int i = 0; i < codes.length; i++) {
      if ((modifier & codes[i]) != 0 && (codes[i] != ACC_INTERFACE)) {
	temp += names[i] + " ";
      }
    }
    return temp;
  }

  // ----------------------------------------------------------------------
  // PRIVATE DATA MEMBERS
  // ----------------------------------------------------------------------

  private static String[] names = {
    "public",
    "private",
    "protected",
    "static",
    "final",
    "synchronized",
    "volatile",
    "transient",
    "native",
    "", //interface not printed here
    "abstract"
  };

  private static int[] codes = {
    ACC_PUBLIC,
    ACC_PRIVATE,
    ACC_PROTECTED,
    ACC_STATIC,
    ACC_FINAL,
    ACC_SYNCHRONIZED,
    ACC_VOLATILE,
    ACC_TRANSIENT,
    ACC_NATIVE,
    ACC_INTERFACE,
    ACC_ABSTRACT
  };
}
