/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: VectorCache.java,v 1.2 2002/03/08 21:55:19 mrobilla Exp $
 */

package at.dms.util;

import java.util.Vector;
import java.util.Stack;

/**
 * This class implements a cache of char arrays
 */
public class VectorCache {

  public static final int SMALL = 0;
  public static final int BIG = 1;

  /**
   * Returns a char array.
   */
  public static synchronized Vector request(int size) {
    if (size == SMALL) {
      if (smalls.empty()) {
	return new Vector();
      } else {
	return (Vector)smalls.pop();
      }
    } else {
      if (bigs.empty()) {
	return new Vector(100);
      } else {
	return (Vector)bigs.pop();
      }
    }
  }

  /**
   * Releases a char array.
   */
  public static void release(Vector vector) {
    vector.setSize(0);
    if (vector.capacity() >= 100) {
      bigs.push(vector);
    } else {
      smalls.push(vector);
    }
  }

  // ----------------------------------------------------------------------
  // PRIVATE DATA MEMBERS
  // ----------------------------------------------------------------------

  private static Stack		smalls = new Stack();
  private static Stack		bigs = new Stack();
}
