/* Generated By:JavaCC: Do not edit this line. JexParser.java */
/** Parses a jex file to return all exceptions that can
  * be thrown by a method.
  * @version $Revision: 1.2 $ $Date: 2002/03/08 21:55:50 $
  */

package ca.ubc.cs.jex.file;

import java.util.Vector;
import java.util.HashSet;
import java.util.Set;
import java.util.Iterator;

public class JexParser implements JexParserConstants {
   /** Returns an array containing the list of exceptions throwns 
     * by the method passed as argument.
     * @param pMethod The method to check
     * @return A Vector of string containing the names of exception
     * thrown by the method
     * @exception ParseException if the file cannot be parsed
     */
   public Set getExceptions( String pSignature ) throws NoSuchMethodException, ParseException, ClassNotFoundException
   {
        Set lReturn =  JexFile( pSignature );
        if( lReturn == null )
           throw new NoSuchMethodException( pSignature );
        return lReturn;
   }

/*****************************************
 * THE JEX LANGUAGE GRAMMAR STARTS HERE *
 *****************************************/

/*
 * Program structuring syntax follows.
 */
  final public HashSet JexFile(String pSignature) throws ParseException, ClassNotFoundException {
  String lMethodSignature;
  HashSet lExceptions;
  HashSet lReturn = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ANONYMOUS:
      jj_consume_token(ANONYMOUS);
      NameList();
      jj_consume_token(SEMICOLON);
      break;
    default:
      jj_la1[0] = jj_gen;
      ;
    }
    label_1:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CONSTRUCTOR:
      case IDENTIFIER:
        ;
        break;
      default:
        jj_la1[1] = jj_gen;
        break label_1;
      }
      lMethodSignature = MethodDeclarator();
      lExceptions = Block();
       if( pSignature.equals( lMethodSignature ))
       {
           lReturn = lExceptions;
       }
    }
    jj_consume_token(0);
    {if (true) return lReturn;}
    throw new Error("Missing return statement in function");
  }

  final public String MethodDeclarator() throws ParseException {
  String lString;
  String lReturn = "";
  Token lToken;
    lReturn = SimpleMethodName();
    lString = FormalParameters();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case THROWS:
      jj_consume_token(THROWS);
      NameList();
      break;
    default:
      jj_la1[2] = jj_gen;
      ;
    }
    {if (true) return lReturn + lString;}
    throw new Error("Missing return statement in function");
  }

  final public String SimpleMethodName() throws ParseException {
  Token lToken;
  String lReturn = "";
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case CONSTRUCTOR:
      jj_consume_token(CONSTRUCTOR);
                    lReturn = "<init>";
      break;
    case IDENTIFIER:
      lToken = jj_consume_token(IDENTIFIER);
                            lReturn = lToken.image;
      break;
    default:
      jj_la1[3] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
      {if (true) return lReturn;}
    throw new Error("Missing return statement in function");
  }

// Accepting SimpleMethodName as the entity is a weakening of the syntax
// check, but is easier to parse.
  final public String Name() throws ParseException {
  String lTemp;
  String lReturn = "";
    lReturn = SimpleMethodName();
    label_2:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case DOT:
        ;
        break;
      default:
        jj_la1[4] = jj_gen;
        break label_2;
      }
      jj_consume_token(DOT);
      lTemp = SimpleMethodName();
      lReturn = lReturn + "." + lTemp;
    }
    {if (true) return lReturn;}
    throw new Error("Missing return statement in function");
  }

  final public String NameList() throws ParseException {
  String lNames;
  String lString;
    lString = Name();
    lNames = lString;
    label_3:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 28:
        ;
        break;
      default:
        jj_la1[5] = jj_gen;
        break label_3;
      }
      jj_consume_token(28);
      lString = Name();
    lNames = lNames + " " + lString;
    }
    {if (true) return lNames;}
    throw new Error("Missing return statement in function");
  }

  final public String FormalParameters() throws ParseException {
  String lString;
  String lParameters = "(";
    jj_consume_token(29);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case BOOLEAN:
    case BYTE:
    case CHAR:
    case CONSTRUCTOR:
    case DOUBLE:
    case FLOAT:
    case INT:
    case LONG:
    case SHORT:
    case IDENTIFIER:
    case 31:
      lString = Type();
    lParameters = lParameters + lString;
      label_4:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case 28:
          ;
          break;
        default:
          jj_la1[6] = jj_gen;
          break label_4;
        }
        jj_consume_token(28);
        lString = Type();
    lParameters = lParameters + "," + lString;
      }
      break;
    default:
      jj_la1[7] = jj_gen;
      ;
    }
    jj_consume_token(30);
    {if (true) return lParameters + ")";}
    throw new Error("Missing return statement in function");
  }

  final public String Type() throws ParseException {
  String lReturn = "";
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case BOOLEAN:
    case BYTE:
    case CHAR:
    case DOUBLE:
    case FLOAT:
    case INT:
    case LONG:
    case SHORT:
      lReturn = PrimitiveType();
      break;
    case CONSTRUCTOR:
    case IDENTIFIER:
      lReturn = Name();
      break;
    case 31:
      lReturn = ArrayType();
      break;
    default:
      jj_la1[8] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    label_5:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 31:
        ;
        break;
      default:
        jj_la1[9] = jj_gen;
        break label_5;
      }
      jj_consume_token(31);
      jj_consume_token(32);
      lReturn = lReturn + "[]";
    }
    {if (true) return lReturn;}
    throw new Error("Missing return statement in function");
  }

  final public String ArrayType() throws ParseException {
   String lReturn = "";
   String lName = "";
   Token lToken;
    label_6:
    while (true) {
      jj_consume_token(31);
         lReturn += "[";
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 31:
        ;
        break;
      default:
        jj_la1[10] = jj_gen;
        break label_6;
      }
    }
    lName = Name();
                    lReturn += lName;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SEMICOLON:
      jj_consume_token(SEMICOLON);
                                             lReturn += ";";
      break;
    default:
      jj_la1[11] = jj_gen;
      ;
    }
     {if (true) return lReturn;}
    throw new Error("Missing return statement in function");
  }

  final public String PrimitiveType() throws ParseException {
  String lReturn;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case BOOLEAN:
      jj_consume_token(BOOLEAN);
      break;
    case CHAR:
      jj_consume_token(CHAR);
      break;
    case BYTE:
      jj_consume_token(BYTE);
      break;
    case SHORT:
      jj_consume_token(SHORT);
      break;
    case INT:
      jj_consume_token(INT);
      break;
    case LONG:
      jj_consume_token(LONG);
      break;
    case FLOAT:
      jj_consume_token(FLOAT);
      break;
    case DOUBLE:
      jj_consume_token(DOUBLE);
      break;
    default:
      jj_la1[12] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  {if (true) return token.image;}
    throw new Error("Missing return statement in function");
  }

  final public HashSet Block() throws ParseException, ClassNotFoundException {
  String lTemp;
  HashSet lExceptions = new HashSet();
  HashSet lNewExceptions;
    jj_consume_token(33);
    label_7:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CONSTRUCTOR:
      case THROWS:
      case TRY:
      case IDENTIFIER:
        ;
        break;
      default:
        jj_la1[13] = jj_gen;
        break label_7;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CONSTRUCTOR:
      case IDENTIFIER:
        lTemp = ExceptionGet();
        jj_consume_token(SEMICOLON);
                                   lExceptions.add( Class.forName( lTemp ));
        break;
      case THROWS:
        lTemp = ExceptionThrow();
        jj_consume_token(SEMICOLON);
                                     lExceptions.add( Class.forName( lTemp ));
        break;
      case TRY:
        lNewExceptions = TryCatch();
                                    lExceptions.addAll( lNewExceptions );
        break;
      default:
        jj_la1[14] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    jj_consume_token(34);
     {if (true) return lExceptions;}
    throw new Error("Missing return statement in function");
  }

  final public String ExceptionGet() throws ParseException {
  String lReturn;
    lReturn = Name();
    jj_consume_token(COLON);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ENVIRONMENT:
      jj_consume_token(ENVIRONMENT);
      break;
    case CONSTRUCTOR:
    case IDENTIFIER:
      Name();
      FormalParameters();
      break;
    default:
      jj_la1[15] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    {if (true) return lReturn;}
    throw new Error("Missing return statement in function");
  }

  final public String ExceptionThrow() throws ParseException {
  String lReturn;
    jj_consume_token(THROWS);
    lReturn = Name();
    {if (true) return lReturn;}
    throw new Error("Missing return statement in function");
  }

  final public HashSet TryCatch() throws ParseException, ClassNotFoundException {
  HashSet lBlockExceptions = new HashSet();
  HashSet lNewExceptions = new HashSet();
  HashSet lFinalExceptions = new HashSet();
  String lString;
    jj_consume_token(TRY);
    lBlockExceptions = Block();
    label_8:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CATCH:
        ;
        break;
      default:
        jj_la1[16] = jj_gen;
        break label_8;
      }
      jj_consume_token(CATCH);
      jj_consume_token(29);
      lString = Name();
        HashSet lRemove = new HashSet();
        Iterator lIterator = lBlockExceptions.iterator();
        while( lIterator.hasNext() )
        {
           Class lNext = (Class) lIterator.next();
           if( Class.forName( lString ).isAssignableFrom( lNext ))
              lRemove.add( lNext );
        }

        lBlockExceptions.removeAll( lRemove );
      jj_consume_token(30);
      lNewExceptions = Block();
    lFinalExceptions.addAll( lNewExceptions );
    }
    lFinalExceptions.addAll( lBlockExceptions );
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FINALLY:
      jj_consume_token(FINALLY);
      lNewExceptions = Block();
    lFinalExceptions.addAll( lNewExceptions );
      break;
    default:
      jj_la1[17] = jj_gen;
      ;
    }
    {if (true) return lFinalExceptions;}
    throw new Error("Missing return statement in function");
  }

  public JexParserTokenManager token_source;
  ASCII_CharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private int jj_gen;
  final private int[] jj_la1 = new int[18];
  final private int[] jj_la1_0 = {0x1000000,0x2002000,0x400000,0x2002000,0x8000,0x10000000,0x10000000,0x823d2540,0x823d2540,0x80000000,0x80000000,0x1000,0x3d0540,0x2c02000,0x2c02000,0x2002080,0x200,0x20000,};
  final private int[] jj_la1_1 = {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,};

  public JexParser(java.io.InputStream stream) {
    jj_input_stream = new ASCII_CharStream(stream, 1, 1);
    token_source = new JexParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 18; i++) jj_la1[i] = -1;
  }

  public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 18; i++) jj_la1[i] = -1;
  }

  public JexParser(java.io.Reader stream) {
    jj_input_stream = new ASCII_CharStream(stream, 1, 1);
    token_source = new JexParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 18; i++) jj_la1[i] = -1;
  }

  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 18; i++) jj_la1[i] = -1;
  }

  public JexParser(JexParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 18; i++) jj_la1[i] = -1;
  }

  public void ReInit(JexParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 18; i++) jj_la1[i] = -1;
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;

  final public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[35];
    for (int i = 0; i < 35; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 18; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 35; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

}
