/* Jex - A tool for analyzing exception flow in Java programs
 *
 *  Copyright (C) 2001 Martin P. Robillard (mrobilla@cs.ubc.ca)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package ca.ubc.cs.jex.util;

import java.io.File;

/** A JarPackageAccessor represent an object that can serve a
  * package from a Jar file.
  * @author $Author: mrobilla $
  * @version $Revision: 1.2 $ $Date: 2002/03/08 21:56:22 $
  */
public class JarPackageAccessor extends ZipPackageAccessor
{
    public JarPackageAccessor( File pPath )
    {
	super( pPath );
    }

    /** Returns true if the argument is a valid jar file
      * @param pFile File to check if we can match to.
      * @return true if the argument is a valid directory
      */
    public static boolean match( File pFile )
    {
	if( pFile.getName().endsWith( FileTypesI.kJar ) )
	    return true;
	else
	    return false;
    }
}	    
